/*
 *  Copyright 1994-2020 Olivier Girondel
 *
 *  This file is part of lebiniou.
 *
 *  lebiniou is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  lebiniou is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with lebiniou. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __BINIOU_EVENT_ENUMS_H
#define __BINIOU_EVENT_ENUMS_H

/*
 * Automagically generated
 * DO NOT EDIT !!!
 */

enum RcptTo {
    BT_NONE = 0,
    BT_IMAGEFADER,
    BT_CMAPFADER,
    BT_PLUGINS,
    BT_CONTEXT,
    BT_SEQMGR,
    BT_LAST,
};

enum Command {
    BC_NONE = 0,
    BC_QUIT,
    BC_PREV,
    BC_NEXT,
    BC_RANDOM,
    BC_SWITCH,
    BC_RESET,
    BC_SELECT,
    BC_RELOAD,
    BC_SET,
    BC_INFO,
    BC_MOVE,
    BC_SAVE,
    BC_USE_BANKSET,
    BC_STORE_BANK,
    BC_USE_BANK,
    BC_CLEAR_BANK,
    BC_SAVE_BANKS,
    BC_SET_BANKMODE,
    BC_LAST,
    BC_LOCK,
    BC_VOLUME_SCALE,
    BC_PARAM_PREV,
    BC_PARAM_NEXT,
    BC_PARAM_DEC,
    BC_PARAM_INC,
    BC_PARAM_DEC_FAST,
    BC_PARAM_INC_FAST,
};

enum Arg {
    BA_NONE = 0,
    BA_RANDOM,
    BA_SEQUENCE,
    BA_SCHEME,
    BA_COLORMAPS,
    BA_IMAGES,
    BA_FULLSCREEN,
    BA_ROTATIONS,
    BA_BOUNDARY,
    BA_OSD_CMAP,
    BA_CURSOR,
    BA_UP,
    BA_SAVE,
    BA_SCREENSHOT,
    BA_DOWN,
    BA_PREV,
    BA_NEXT,
    BA_LAYER_MODE,
    BA_SELECTED,
    BA_LENS,
    BA_BYPASS,
    BA_WEBCAM,
    BA_PULSE,
    BA_LAST,
    BA_MUTE,
    BA_SEQUENCE_FULL,
    BA_SEQUENCE_BARE,
    BA_OVERWRITE_FULL,
    BA_OVERWRITE_BARE,
};


#endif /* __BINIOU_EVENT_ENUMS_H */
